// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/bbtest/gpio.c $
// $Rev: 51802 $
// $Date: 2022-10-14 12:32:06 -0500 (Fri, 14 Oct 2022) $

// DIO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _walking_0(int fd_1, int fd_2)
{
	int	errs	= 0;
	u32	get;
	int	i;
	int	rx;
	u32	set;
	int	tx;
	int	xfer	= 0;

	gsc_label("Walking 0");

	// Initialize both devices/
	errs	+= dio32_initialize(fd_1, -1, 0);
	errs	+= dio32_initialize(fd_2, -1, 0);

	// Configure the first device as all outputs.
	// Leave the second device as all inputs.
	errs	+= dio32_io_out_dir(fd_1, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, 0xFFFFFFFF, NULL);

	// Walk the value.

	for (i = 0; (errs == 0) && (i <= 31); i++)
	{
		set		= ~(1 << i);
		tx		= dio32_io_out_val	(fd_1, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, set, NULL);
		os_sleep_ms(10);
		rx		= dio32_io_in_get	(fd_2, -1, 0, &get);
		xfer	+= tx + rx;

		if ((tx == 0) && (rx == 0) && (get != set))
		{
			xfer++;
			printf(	"ERROR <---  (output 0x%08lX, but read 0x%08lX instead)\n",
					(unsigned long) set,
					(unsigned long) get);
		}
	}

	errs	+= xfer;

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}



//*****************************************************************************
static int _walking_1(int fd_1, int fd_2)
{
	int	errs	= 0;
	u32	get;
	int	i;
	int	rx;
	u32	set;
	int	tx;
	int	xfer	= 0;

	gsc_label("Walking 1");

	// Initialize both devices/
	errs	+= dio32_initialize(fd_1, -1, 0);
	errs	+= dio32_initialize(fd_2, -1, 0);

	// Configure the first device as all outputs.
	// Leave the second device as all inputs.
	errs	+= dio32_io_out_dir(fd_1, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, 0xFFFFFFFF, NULL);

	// Walk the value.

	for (i = 0; (errs == 0) && (i <= 31); i++)
	{
		set		= 1 << i;
		tx		= dio32_io_out_val	(fd_1, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, set, NULL);
		os_sleep_ms(10);
		rx		= dio32_io_in_get	(fd_2, -1, 0, &get);
		xfer	+= tx + rx;

		if ((tx == 0) && (rx == 0) && (get != set))
		{
			xfer++;
			printf(	"ERROR <---  (output 0x%08lX, but read 0x%08lX instead)\n",
					(unsigned long) set,
					(unsigned long) get);
		}
	}

	errs	+= xfer;

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}



//*****************************************************************************
static int _tests(int index_1, int fd_1, int index_2, int fd_2)
{
	char	buf[64];
	int		errs	= 0;

	if (index_1 == index_2)
		sprintf(buf, "GPIO Tests (#%d, loopback)", index_1);
	else
		sprintf(buf, "GPIO Tests (#%d => #%d)", index_1, index_2);

	gsc_label(buf);
	printf("\n");
	gsc_label_level_inc();

	errs	+= _walking_0(fd_1, fd_2);
	errs	+= _walking_1(fd_1, fd_2);

	gsc_label_level_dec();
	return(errs);
}



//*****************************************************************************
int gpio_tests(int index_1, int fd_1, int index_2, int fd_2)
{
	int	errs	= 0;

	if (index_1 == index_2)
	{
		errs	+= _tests(index_1, fd_1, index_2, fd_2);
	}
	else
	{
		errs	+= _tests(index_1, fd_1, index_2, fd_2);
		errs	+= _tests(index_2, fd_2, index_1, fd_1);
	}

	return(errs);
}


