// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/din/main.h $
// $Rev: 51803 $
// $Date: 2022-10-14 12:32:49 -0500 (Fri, 14 Oct 2022) $

// DIO32: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdlib.h>
#include <time.h>

#include "dio32_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings
	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;
	s32	ms_wait;		// Wait between readings?
	s32	raw;			// Read the raw or the deglitched input?
	s32	seconds;		// Monitor the inputs for this long.
	s32	test_limit;

	int	fd;

	// Device Settings
	s32	deglitch_ms;
	s32	deglitch_us;
} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);



#endif
