// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/id/perform.c $
// $Rev: 51805 $
// $Date: 2022-10-14 12:33:21 -0500 (Fri, 14 Oct 2022) $

// DIO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _id_device_frr(const args_t* args)
{
	gsc_reg_def_t	list[2]	= { { NULL }, { NULL } };
	gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= (gsc_reg_def_t*) dio32_reg_get_def_id(DIO32_GSC_FRR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, dio32_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. dio32_reg_get_def_id, DIO32_GSC_FRR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _id_device_fr(const args_t* args)
{
	gsc_reg_def_t	list[2]	= { { NULL }, { NULL } };
	gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= (gsc_reg_def_t*) dio32_reg_get_def_id(DIO32_GSC_FR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, dio32_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. dio32_reg_get_def_id, DIO32_GSC_FR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _id_device_bsr(const args_t* args)
{
	gsc_reg_def_t	list[2]	= { { NULL }, { NULL } };
	gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= (gsc_reg_def_t*) dio32_reg_get_def_id(DIO32_GSC_BSR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, dio32_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. dio32_reg_get_def_id, DIO32_GSC_BSR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	for (i = 0; i < DIO32_IOCTL_QUERY_LAST; i++)
		errs	+= dio32_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_frr(args);
	errs	+= _id_device_fr(args);
	errs	+= _id_device_bsr(args);
	printf("\n");

	return(errs);
}


