// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/regs/perform.c $
// $Rev: 51808 $
// $Date: 2022-10-14 12:36:41 -0500 (Fri, 14 Oct 2022) $

// DIO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _dump_everything(int fd)
{
	os_id_host();
	printf("\n");
	os_id_driver(dio32_open, dio32_read, dio32_close);
	printf("\n");
	dio32_id_device(fd, -1, 1);
	printf("\n");

	gsc_reg_plx9056_list_pci(fd, dio32_reg_read);
	printf("\n");

	gsc_reg_plx9056_list_plx(fd, dio32_reg_read);
	printf("\n");
	dio32_reg_list(fd, 1);
}



//*****************************************************************************
static void _dump_gsc(int fd)
{
	dio32_reg_list(fd, 0);
}



//*****************************************************************************
static void _dump_gsc_detail(int fd)
{
	dio32_reg_list(fd, 1);
}



//*****************************************************************************
static void _dump_pci(int fd)
{
	gsc_reg_plx9056_list_pci(fd, dio32_reg_read);
}



//*****************************************************************************
static void _dump_plx(int fd)
{
	gsc_reg_plx9056_list_plx(fd, dio32_reg_read);
}



//*****************************************************************************
static void _id_device(int fd)
{
	dio32_id_device(fd, -1, 1);
}



//*****************************************************************************
static void _id_driver(int fd)
{
	os_id_driver(dio32_open, dio32_read, dio32_close);
}



//*****************************************************************************
static void _id_host(int fd)
{
	os_id_host();
}



//****************************************************************************
int perform_tests(int fd)
{
	static const menu_item_t	list[]	=
	{
		// name								func
		{ "Dump Everything",				_dump_everything	},
		{ "Host OS Identification",			_id_host			},
		{ "Driver Identification",			_id_driver			},
		{ "Device Identification",			_id_device			},
		{ "PCI Register Dump",				_dump_pci			},
		{ "PLX Register Dump",				_dump_plx			},
		{ "GSC Register Dump",				_dump_gsc			},
		{ "GSC Register Detail Dump",		_dump_gsc_detail	},
		{ "Edit GSC Register By Name",		reg_mod_by_name		},
		{ "Edit GSC Register By Offset",	reg_mod_by_offset	},
		{ NULL,								NULL				}
	};

	static const menu_t	menu	=
	{
		/* title	*/	"Main Menu",
		/* list		*/	list
	};

	printf("\n\n");
	printf("Register Access Application\n");
	menu_call(fd, &menu);
	return(0);
}



