// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/sbtest/led1.c $
// $Rev: 51807 $
// $Date: 2022-10-14 12:34:33 -0500 (Fri, 14 Oct 2022) $

// DIO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DIO32_IOCTL_LED1,
			/* arg		*/	DIO32_LED_OFF,
			/* reg		*/	DIO32_GSC_BCR,
			/* mask		*/	0x00C,
			/* value	*/	0x000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DIO32_IOCTL_LED1,
			/* arg		*/	DIO32_LED_GREEN,
			/* reg		*/	DIO32_GSC_BCR,
			/* mask		*/	0x00C,
			/* value	*/	0x004
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DIO32_IOCTL_LED1,
			/* arg		*/	DIO32_LED_RED,
			/* reg		*/	DIO32_GSC_BCR,
			/* mask		*/	0x00C,
			/* value	*/	0x008
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DIO32_IOCTL_LED1,
			/* arg		*/	DIO32_LED_BOTH,
			/* reg		*/	DIO32_GSC_BCR,
			/* mask		*/	0x00C,
			/* value	*/	0x00C
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;
	int	ret;
	s32	val;

	errs	+= dio32_initialize(fd, -1, 0);

	errs	+= service_ioctl_reg_get_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= service_ioctl_reg_get_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);

	// Verify that errors are reported.
	errs	+= dio32_initialize(fd, -1, 0);

	// valid:
	val	= DIO32_LED_OFF;
	ret	= dio32_ioctl(fd, DIO32_IOCTL_LED0, &val);

	if (ret)
	{
		errs++;
		printf("FAIL <---  (%d. failure reported, but shouldn't)\n", __LINE__);
	}

	// valid:
	val	= -1;
	ret	= dio32_ioctl(fd, DIO32_IOCTL_LED0, &val);

	if (ret)
	{
		errs++;
		printf("FAIL <---  (%d. failure reported, but shouldn't)\n", __LINE__);
	}

	// invalid: value
	val	= -2;
	ret	= dio32_ioctl(fd, DIO32_IOCTL_LED0, &val);

	if (ret == 0)
	{
		errs++;
		printf("FAIL <---  (%d. failure not reported: value)\n", __LINE__);
	}

	// invalid: value
	val	= 4;
	ret	= dio32_ioctl(fd, DIO32_IOCTL_LED0, &val);

	if (ret == 0)
	{
		errs++;
		printf("FAIL <---  (%d. failure not reported: value)\n", __LINE__);
	}

	errs	+= dio32_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// Not testabe without additional equipment.
	// It can be verified via the "led" sample application.
	return(0);
}



/******************************************************************************
*
*	Function:	led1_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DIO32_IOCTL_LED1.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int led1_test(int fd)
{
	int	errs	= 0;

	gsc_label("DIO32_IOCTL_LED1");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


